-- new way of defining boosts
-- needs more options to control vfx and such

-- Still missing sneakers and panels implementation

local FRACUNIT = FRACUNIT
local BT_BRAKE = BT_BRAKE
local KITEM_SNEAKER = KITEM_SNEAKER
local k_startboost = k_startboost
local k_driftboost = k_driftboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_sneakertimer = k_sneakertimer
local k_itemtype = k_itemtype
local k_itemamount = k_itemamount
local k_driftcharge = k_driftcharge
local k_rocketsneakertimer = k_rocketsneakertimer
local k_floorboost = k_floorboost

local prefix = "blib_"

local cv_panelstack = CV_RegisterVar({
    name = prefix.."panelstack",
    defaultvalue = "1",
    flags = CV_NETVAR,
    PossibleValue = {MIN = 1, MAX = 3}
})

local cv_sneakerstack = CV_RegisterVar({
    name = prefix.."sneakerstack",
    defaultvalue = "1",
    flags = CV_NETVAR,
    PossibleValue = {MIN = 1, MAX = 5}
})

-- When this is set to 0, it uses the vanilla values based on gamespeed
local cv_sneakeritemboost = CV_RegisterVar({
    name = prefix.."sneakeritemboost",
    defaultvalue = "0.0", -- If you're on hard speed and want more catchup power, I recommend 0.375
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_sneakeritemaccel = CV_RegisterVar({
    name = prefix.."sneakeritemaccel",
    defaultvalue = "8",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

-- When this is set to 0, it uses the vanilla values basedm on gamespeed
local cv_sneakerpanelboost = CV_RegisterVar({
    name = prefix.."sneakerpanelboost",
    defaultvalue = 0,
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_sneakerpanelaccel = CV_RegisterVar({
    name = prefix.."sneakerpanelaccel",
    defaultvalue = "8",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_driftboost = CV_RegisterVar({
    name = prefix.."driftboost",
    defaultvalue = "0.25",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_invincibilityboost = CV_RegisterVar({
    name = prefix.."invincibilityboost",
    defaultvalue = "0.375",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_invincibilityaccel = CV_RegisterVar({
    name = prefix.."invincibilityaccel",
    defaultvalue = "3.0",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_growboost = CV_RegisterVar({
    name = prefix.."growboost",
    defaultvalue = "0.30", -- recommend 0.30 for grow tweaks
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_growaccel = CV_RegisterVar({
    name = prefix.."growaccel",
    defaultvalue = "0.5", -- recommend 0.50 for grow tweaks
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_growboostmult = CV_RegisterVar({
    name = prefix.."growboostmult",
    defaultvalue = "-0.3", -- recommended for grow tweaks -0.3
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = INT32_MIN, MAX = INT32_MAX},
})

local cv_chainoffroadimmunity = CV_RegisterVar({
    name = prefix.."chainoffroadimmunity",
    defaultvalue = "Off",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

local pks, pmo

local function panelchainfunc(player, name, timer)
	pmo = player.mo
	if  timer > pmo.panelsneakertimer then
		pmo.panelsneakertimer = timer
		if cv_chainoffroadimmunity.value then
			pmo.naturalpanelsneakertimer = timer
		end
	end
	return pmo.panelsneakertimer
end
BLib.RegisterChainFunc("panelsneaker", panelchainfunc)

local function sneakerchainfunc(player, name, timer)
	pmo = player.mo
	if  timer > pmo.itemsneakertimer then
		pmo.itemsneakertimer = timer
		if cv_chainoffroadimmunity.value then
			pmo.naturalitemsneakertimer = timer
		end
	end
	return pmo.itemsneakertimer
end
BLib.RegisterChainFunc("itemsneaker", sneakerchainfunc)

local function driftchainfunc(player, name, timer)
	pks = player.kartstuff
	if  timer > pks[k_driftboost] then
		pks[k_driftboost] = timer
	end
	return pks[k_driftboost]
end
BLib.RegisterChainFunc("drift", driftchainfunc)

local section, special = 2, 6 -- for the map specific panels
local vanillasneakertime = 47
local gamespeedsneakerstrength = { 53740+768, 32768, 17294+768}
local starttime = 6*TICRATE + (3*TICRATE/4)
local player, tempsneakerstrength
addHook("MobjThinker", function(mo)
	if not BLib then return end
	player = mo.player
	pks = mo.player.kartstuff
	
	-- Determine the outcome of your charge.
	if leveltime == starttime+1 and pks[k_sneakertimer] then
		mo.naturalpanelsneakertimer = vanillasneakertime
		mo.panelsneakertimer = pks[k_sneakertimer]
		mo.stackedpanels = 1
	end
	
	
	-- panel sneakers
	-- check for initial boost for chain and stack purposes
	if pks[k_floorboost] then
		if not mo.BLlastframefloorboost then
			if P_PlayerTouchingSectorSpecial(player, section, special) then  -- for the map specific panels
				mo.stackedpanels = min(($ or 0)+1, 3)
			else
				mo.stackedpanels = min(($ or 0)+1,cv_panelstack.value)
			end
			mo.resetboostflame = true
		end
		mo.naturalpanelsneakertimer = vanillasneakertime
		pks[k_sneakertimer] = vanillasneakertime
		mo.panelsneakertimer = max(BLib.BoostChain(player, "panelsneaker", vanillasneakertime), vanillasneakertime) + 1
	end
	
	-- apply boost
	if mo.panelsneakertimer then
		if cv_sneakerpanelboost.value == 0 then
			tempsneakerstrength = gamespeedsneakerstrength[gamespeed+1]
		else
			tempsneakerstrength = cv_sneakerpanelboost.value
		end
		tempsneakerstrength = $ * mo.stackedpanels
		BLib.SetBoost(player, "panelsneaker", tempsneakerstrength, cv_sneakerpanelaccel.value, nil, true, true, true)
	else
		BLib.SetBoost(player, "panelsneaker")
	end
	
	if not mo.panelsneakertimer then mo.stackedpanels = 0 end

	-- item sneakers
	-- check for initial boost for chain and stack purposes
	if ((JUICEBOX and JUICEBOX.value) or (player.BLlastframebutton == 0 and (player.cmd.buttons & BT_ATTACK))) and
	((player.BLlastframeitem == KITEM_SNEAKER and pks[k_itemamount] < player.BLlastframeamount) or
	(pks[k_rocketsneakertimer] < (mo.BLlastframerocketsneakertimer or 0)-1)) then
		mo.naturalitemsneakertimer = vanillasneakertime
		pks[k_sneakertimer] = vanillasneakertime
		mo.itemsneakertimer = max(BLib.BoostChain(player, "itemsneaker", vanillasneakertime), vanillasneakertime) + 1
		mo.stackedsneakers = min(($ or 0)+1,cv_sneakerstack.value)
		if (pks[k_rocketsneakertimer] < (mo.BLlastframerocketsneakertimer or 0)-1) then
			mo.stackedrockets = min(($ or 0)+1,cv_sneakerstack.value)
			if mo.hnext then 
				mo.hnext.resetboostflame = true
				if mo.hnext.hnext then mo.hnext.hnext.resetboostflame = true end
			end
		else
			mo.resetboostflame = true
		end
	end

	-- apply boost
	if mo.itemsneakertimer then
		if cv_sneakeritemboost.value == 0 then
			tempsneakerstrength = gamespeedsneakerstrength[gamespeed+1]
		else
			tempsneakerstrength = cv_sneakeritemboost.value
		end
		
		tempsneakerstrength = $ * mo.stackedsneakers
		BLib.SetBoost(player, "itemsneaker", tempsneakerstrength, cv_sneakeritemaccel.value, nil, true, true, true)
	else
		BLib.SetBoost(player, "itemsneaker")
	end

	if not mo.itemsneakertimer then 
		mo.stackedsneakers = 0
		mo.stackedrockets = 0
	end

	if pks[k_startboost] then
		BLib.SetBoost(player, "startboost", FRACUNIT/4, FRACUNIT*6, nil, true, true, false)
	else
		BLib.SetBoost(player, "startboost")
	end

	if pks[k_driftboost] and (mo.BLlastdriftcharge or 0) > pks[k_driftcharge] and (mo.BLlastdriftcharge or 0) >= K_GetKartDriftSparkValue(player) then
		pks[k_driftboost] = max(BLib.BoostChain(player, "drift", $), $)
	end

	if pks[k_driftboost] then
		BLib.SetBoost(player, "drift", cv_driftboost.value, FRACUNIT*4, nil, true, true, true)
	else
		BLib.SetBoost(player, "drift")
	end
	
	if pks[k_invincibilitytimer] then
		BLib.SetBoost(player, "invincibility", cv_invincibilityboost.value, cv_invincibilityaccel.value, nil, true, true, false)
	else
		BLib.SetBoost(player, "invincibility")
	end
	
	if pks[k_growshrinktimer] > 0 then
		BLib.SetBoost(player, "grow", cv_growboost.value, cv_growaccel.value, 0, false, false, false)
		BLib.SetBoost(player, "growboostmult", 0, 0, cv_growboostmult.value, true, false, false) -- Two separate entries since we want the boostpower to stack but the base speedboost to not stack
	else
		BLib.SetBoost(player, "grow")
		BLib.SetBoost(player, "growboostmult")
	end	
	
	player.BLlastframebutton = (player.cmd.buttons & BT_ATTACK) and ($ or 0)+1
	player.BLlastframeitem = pks[k_itemtype]
	player.BLlastframeamount = pks[k_itemamount]
	-- stuff stored on the mo automatically clears on respawn
	mo.BLlastdriftcharge = pks[k_driftcharge]
	mo.BLlastframerocketsneakertimer = pks[k_rocketsneakertimer]
	mo.BLlastframefloorboost = pks[k_floorboost]
	mo.naturalitemsneakertimer = max(0, ($ or 0)-1)
	mo.naturalpanelsneakertimer = max(0, ($ or 0)-1)
	mo.itemsneakertimer = max(0, ($ or 0)-1)
	mo.panelsneakertimer = max(0, ($ or 0)-1)
end, MT_PLAYER)

-- Needed to reset these between maps since the above is a mobjthinker
addHook("MapChange", function(mapnum)
	for player in players.iterate do
		player.BLlastframebutton = 0
		player.BLlastframeitem = 0
		player.BLlastframeamount = 0
	end
end)